/* Steal VBI */
/*
   How to get a VBI routine executing:
   
   The system maintains a list of vectors that point to routines to be
executed during the VBI, to have your routine serviced, all one need do
is find an unused slot, and put the address of your routine in!
   This source code will do just that.  Bear in mind that it does not
know what to do if all 8 default slots are in use (it's fairly straight-
forward to fix, but not in here).  Note also that this program DOES NOT
release it's workspace on termination, since the VBI is a function in this
program (otherwise, the VBI code would disappear when the memory was
returned to the system.  To fix that, allocate some memory for the VBI,
and then move it there.)  The overhead is not much in this instance, but
it could be a factor on machines with limited amounts of memory.

This is not the best example of how to set up a VBI, but it WILL show you
how.  To the best of my knowledge, this code functions as advertised, but
I can not be held responsible for any problems you may encounter, you are
on your own! (hey, it works on my machine.)

This particular routine will just put a blinking block near the top of
your screen.  To make use this code, just replace MyVBI() with your
own code. Enjoy!

This source is (c)1991 by NecroWare Development.
It may be distributed as long as no charge is made for it.

-Ken Schafer January 4, 1992

 NecroWare Development
 Box 688
 Clark Mills, New York, 13321-0688

 GEnie : K.Schafer4
 Delphi: KSchafer
*/


#include <osbind.h>

extern MyVBI();            /* The name of your VBI routine */
long *vector;              /* pointer to VBI vector */
int n_vecs;				   /* holds # of already installed VBI's */
long screen;               
long data;                

main()
{ 
    long user_stack=Super(0L);           /* Supervisor mode */
	vector = (long *)(*(long *)0x456);   /* get 1st VBI vec.*/
    n_vecs = 1;                          /* gotta be 1 anyway! */
    while (*vector != 0 && n_vecs<8)    
       vector++;                         /* search for empty slot */
    if ( n_vecs >8 )                     /* Die if there aren't any */
       Pterm(0);                         /* ( a rare occurance, but you
                                              should put code here to check
                                              for it ) */
                       
    screen = Physbase();

    *(int *)0x452 = 0;                   /* stop interrupts */ 
    *vector = (long)MyVBI;               /* add our routine to queue */
    *(int *)0x452 = 1;                   /* turn VBI's back on */
    Ptermres(20000,0);                   /* exit, leave room for VBI code */

}

MyVBI()                                  /* put your VBI code here */
{
    data ++;                             /* tick, tick, tick, tick */
	if (data == 30)
	    *(long *)screen = 0xFFFFFFFF;    /* Now you see it */
    if (data == 60){
		data = 0;
		*(long *)screen = 0;             /* Now you don't */
    }
}


